
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java逆向基础之动态生成类 / 憋错料</title>

    <meta name="description" content="Java逆向基础之动态生成类 为什么有这个东西,一方面时AOP框架的需要,另一方面是增加软件逆向的难度 动态生成类的技术目前大体上分为两类,一类是通过操作字节码框架如cglib/Javassist去实现,另一类就是JNI方式,调用dll/so库,内存中动态还原.这两种方式都能实现隐藏类 看一个Javassist动态生成类的例子 package com.vvvtimes; import java.lang.reflect.Modifier; import javassist.ClassPool; import javassis">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Java逆向基础之动态生成类</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>为什么有这个东西，一方面时AOP框架的需要，另一方面是增加软件逆向的难度</p>
<p>动态生成类的技术目前大体上分为两类，一类是通过操作字节码框架如cglib/Javassist去实现，另一类就是JNI方式，调用dll/so库，内存中动态还原。这两种方式都能实现隐藏类</p>
<p>看一个Javassist动态生成类的例子</p>
<pre>package&nbsp;com.vvvtimes;

import&nbsp;java.lang.reflect.Modifier;

import&nbsp;javassist.ClassPool;
import&nbsp;javassist.CtClass;
import&nbsp;javassist.CtConstructor;
import&nbsp;javassist.CtField;
import&nbsp;javassist.CtMethod;
import&nbsp;javassist.CtNewMethod;

public&nbsp;class&nbsp;DynamicGenerateClass&nbsp;{

	public&nbsp;static&nbsp;void&nbsp;main(String[]&nbsp;args)&nbsp;throws&nbsp;Exception&nbsp;{

		//&nbsp;ClassPool：CtClass对象的容器
		ClassPool&nbsp;pool&nbsp;=&nbsp;ClassPool.getDefault();

		//&nbsp;通过ClassPool生成一个public新类Employee.java
		CtClass&nbsp;ctClass&nbsp;=&nbsp;pool.makeClass(&quot;com.vvvtimes.bean.Employee&quot;);

		//&nbsp;添加字段
		//&nbsp;首先添加字段private&nbsp;String&nbsp;ename
		CtField&nbsp;enameField&nbsp;=&nbsp;new&nbsp;CtField(pool.getCtClass(&quot;java.lang.String&quot;),&nbsp;&quot;ename&quot;,&nbsp;ctClass);
		enameField.setModifiers(Modifier.PRIVATE);
		ctClass.addField(enameField);

		//&nbsp;其次添加字段privtae&nbsp;int&nbsp;eage
		CtField&nbsp;eageField&nbsp;=&nbsp;new&nbsp;CtField(pool.getCtClass(&quot;int&quot;),&nbsp;&quot;eage&quot;,&nbsp;ctClass);
		eageField.setModifiers(Modifier.PRIVATE);
		ctClass.addField(eageField);

		//&nbsp;其次添加字段privtae&nbsp;int&nbsp;eage
		CtField&nbsp;esexField&nbsp;=&nbsp;new&nbsp;CtField(pool.getCtClass(&quot;int&quot;),&nbsp;&quot;esex&quot;,&nbsp;ctClass);
		esexField.setModifiers(Modifier.PRIVATE);
		ctClass.addField(esexField);

		//&nbsp;为字段ename和eno添加getter和setter方法
		ctClass.addMethod(CtNewMethod.getter(&quot;getEname&quot;,&nbsp;enameField));
		ctClass.addMethod(CtNewMethod.setter(&quot;setEname&quot;,&nbsp;enameField));
		ctClass.addMethod(CtNewMethod.getter(&quot;getEage&quot;,&nbsp;eageField));
		ctClass.addMethod(CtNewMethod.setter(&quot;setEage&quot;,&nbsp;eageField));
		ctClass.addMethod(CtNewMethod.getter(&quot;getSex&quot;,&nbsp;esexField));
		ctClass.addMethod(CtNewMethod.setter(&quot;setSex&quot;,&nbsp;esexField));

		//&nbsp;添加构造函数
		CtConstructor&nbsp;ctConstructor&nbsp;=&nbsp;new&nbsp;CtConstructor(new&nbsp;CtClass[]&nbsp;{},&nbsp;ctClass);
		//&nbsp;为构造函数设置函数体
		StringBuffer&nbsp;buffer&nbsp;=&nbsp;new&nbsp;StringBuffer();
		buffer.append(&quot;{\n&quot;).append(&quot;ename=\&quot;gsls200808\&quot;;\n&quot;).append(&quot;eage=25;\n&quot;).append(&quot;esex=1;\n}&quot;);
		ctConstructor.setBody(buffer.toString());
		//&nbsp;把构造函数添加到新的类中
		ctClass.addConstructor(ctConstructor);

		//&nbsp;添加自定义方法
		CtMethod&nbsp;ctMethod&nbsp;=&nbsp;new&nbsp;CtMethod(CtClass.voidType,&nbsp;&quot;printInfo&quot;,&nbsp;new&nbsp;CtClass[]&nbsp;{},&nbsp;ctClass);
		//&nbsp;为自定义方法设置修饰符
		ctMethod.setModifiers(Modifier.PUBLIC);
		//&nbsp;为自定义方法设置函数体
		StringBuffer&nbsp;buffer2&nbsp;=&nbsp;new&nbsp;StringBuffer();
		buffer2.append(&quot;{\n&quot;).append(&quot;System.out.println(\&quot;begin!\&quot;);\n&quot;)
				.append(&quot;System.out.println(\&quot;name=\&quot;+ename);\n&quot;).append(&quot;System.out.println(\&quot;age=\&quot;+eage);\n&quot;)
				.append(&quot;System.out.println(\&quot;sex=\&quot;+esex);\n&quot;).append(&quot;System.out.println(\&quot;end!\&quot;);\n&quot;).append(&quot;}&quot;);
		ctMethod.setBody(buffer2.toString());
		ctClass.addMethod(ctMethod);

		//&nbsp;为了验证效果，下面使用反射执行方法printInfo
		Class&lt;?&gt;&nbsp;clazz&nbsp;=&nbsp;ctClass.toClass();
		Object&nbsp;obj&nbsp;=&nbsp;clazz.newInstance();
		obj.getClass().getMethod(&quot;printInfo&quot;,&nbsp;new&nbsp;Class[]&nbsp;{}).invoke(obj,&nbsp;new&nbsp;Object[]&nbsp;{});

	}
}</pre>
<p>需要引用的第三方jar：<a href="http://central.maven.org/maven2/org/javassist/javassist/3.20.0-GA/javassist-3.20.0-GA.jar" rel="external nofollow noreferrer">javassist-3.20.0-GA.jar</a></p>
<p>运行结果</p>
<pre>begin!
name=gsls200808
age=25
sex=1
end!</pre>
<p>代码的意思相当于在内存中创建了一个名为com.vvvtimes.bean.Employee的类，并通过反射方式调用了printInfo方法进行输出。</p>
<p>这个类的内容大致如下，只不过我们在上面是动态生成的</p>
<pre>package&nbsp;com.vvvtimes.bean;

import&nbsp;java.io.PrintStream;

public&nbsp;class&nbsp;Employee
{
&nbsp;&nbsp;private&nbsp;String&nbsp;ename&nbsp;=&nbsp;&quot;gsls200808&quot;;
&nbsp;&nbsp;private&nbsp;int&nbsp;eage&nbsp;=&nbsp;25;
&nbsp;&nbsp;private&nbsp;int&nbsp;esex&nbsp;=&nbsp;1;
&nbsp;&nbsp;
&nbsp;&nbsp;public&nbsp;String&nbsp;getEname()
&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;this.ename;
&nbsp;&nbsp;}
&nbsp;&nbsp;
&nbsp;&nbsp;public&nbsp;void&nbsp;setEname(String&nbsp;paramString)
&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;this.ename&nbsp;=&nbsp;paramString;
&nbsp;&nbsp;}
&nbsp;&nbsp;
&nbsp;&nbsp;public&nbsp;int&nbsp;getEage()
&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;this.eage;
&nbsp;&nbsp;}
&nbsp;&nbsp;
&nbsp;&nbsp;public&nbsp;void&nbsp;setEage(int&nbsp;paramInt)
&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;this.eage&nbsp;=&nbsp;paramInt;
&nbsp;&nbsp;}
&nbsp;&nbsp;
&nbsp;&nbsp;public&nbsp;int&nbsp;getSex()
&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;this.esex;
&nbsp;&nbsp;}
&nbsp;&nbsp;
&nbsp;&nbsp;public&nbsp;void&nbsp;setSex(int&nbsp;paramInt)
&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;this.esex&nbsp;=&nbsp;paramInt;
&nbsp;&nbsp;}
&nbsp;&nbsp;
&nbsp;&nbsp;public&nbsp;void&nbsp;printInfo()
&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(&quot;begin!&quot;);
&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(&quot;name=&quot;&nbsp;+&nbsp;this.ename);
&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(&quot;age=&quot;&nbsp;+&nbsp;this.eage);
&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(&quot;sex=&quot;&nbsp;+&nbsp;this.esex);
&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(&quot;end!&quot;);
&nbsp;&nbsp;}
}</pre>
<p>在后续文章中我们会讲如何获取内存中的类</p>

<p>原文地址：http://blog.51cto.com/7317859/2106653</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 22:00:51 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/java%e5%8a%a8%e6%80%81%e7%94%9f%e6%88%90%e7%b1%bb/" title="java动态生成类">java动态生成类</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Java逆向基础之动态生成类的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41aQgg4.html" rel="bookmark">Java逆向基础之导出内存中的类一</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为什么需要这个,因为在之前的博文中提到,为了增加逆向的难度,部分软件会对部分关键方法和类进行隐藏,所以我们需要把这个类从内存中拿出来. 本文介绍使用javaagent的方法,下一篇介绍dumpclass,两种方法各有利弊. 本文需要用到第三方jar为:javassist-3.20.0-GA.jar,不过我们需要的是它的源码javassist-3.20.0-GA-sources.jar 新建名为DumpClassAgent的项目,项目结构如下 将下载到的源码复制到src目录下 DumpClassA			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDRjkK3.html" rel="bookmark">构建施耐德楼控系统数据库后台服务器示例工程五（JAVA动态生成类）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在做数据库简易工具的过程中遇到了这么一个问题,即程序部署在tomcat下启动运行后,我们无法事先定义数据库中后续创建的表结构的Hibernate Bean对象,这样就需要我们在服务器运行起来后动态创建bean对象.cglib这个开源库即可解决我们的问题,动态创建JAVA对象. 1.cglib开源库简介 CGLIB(Code Generation Library)是一个开源项目,是一个强大的,高性能,高质量的Code生成类库,它可以在运行期扩展Java类与实现Java接口. 反编译后CGLIB结构			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/BMzQE84.html" rel="bookmark">C&plus;&plus;实现根据类名动态生成类对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在开发后台服务的过程中,我们常常需要从数据库中取数据,并将数据缓存在本地中,另外,我们的服务还需要有更新数据的能力:包括定时的主动更新以及数据库数据更新时服务收到通知的被动更新. 之前在需要用到以上功能的时候,模仿着组内通用的数据Cache部分的代码来写,十分方便,基本上只需要自己写两个类:一个是取数据并缓存数据的类XXXData,一个是扇出数据的类XXXFetcher. 在需要使用数据的时候,通过: FetcherFactory::getFetcher&lt;XXXFetcher&gt;() 即可获取一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Z9zx80.html" rel="bookmark">Java逆向基础之Byteman的扩展Helper类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇文章提到我们可以在规则文件中调用自己写的扩展Helper类 看一个例子 新建目标项目和扩展Helper类项目,结构如下 其中目标项目使用上一篇博客的第二个例子的代码 扩展Helper类项目需要用到第三方jar,在C:\byteman-download-4.0.2\lib找到byteman.jar复制过来 TraceHelper.java代码如下 package com.vvvtimes; import org.jboss.byteman.rule.Rule; import org.jbos			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e9AJE0.html" rel="bookmark">怎样用java编程抓取动态生成的网页</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在做项目的时候有一个需求:从网页面抓取数据,要求是首先抓取整个网页的html源码(后期更新要使用到).刚开始一看这个简单,然后就稀里哗啦的敲起了代码(在这之前使用过Hadoop平台的分布式爬虫框架Nutch,使用起来是很方便,但是最后因为速度的原因放弃了,但生成的统计信息在后来的抓取中使用到了),很快holder.html和finance.html页面成功下载完成,然后解析完holder.html页面之后再解析finance.html,然后很沮丧的发现在这个页面中我需要的数据并没有在html			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e2PNp3.html" rel="bookmark">Java逆向基础之JDB动态调试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文参考:https://docs.oracle.com/javase/8/docs/technotes/tools/windows/jdb.html JDB在有源代码的时候可以实现调试远程机器上的java程序,但是在逆向中源码很难分析出来,不过还是能够调试得到一部分信息的 本文主要获取两个信息 1.动态调用混淆类中的方法,因为实践过程中我们去手动补全相关代码比较难 2.打印调用栈 以下例子以调试ZKM.jar为例 JDB无源代码调试调用方法 启动Xdebug调试 java -Xdebug -X			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0krmwXM.html" rel="bookmark">java 动态生成类再编译最后代理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package spring.vhostall.com.proxy; public interface Store { public void sell(); } -------------------------------------------- package spring.vhostall.com.proxy; public class Supermarket implements Store { @Override public void sell() { System.out.pr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O8GaZ4.html" rel="bookmark">Java逆向基础之导出内存中的类二</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们有时候可能会遇到暂时无法使用javaagent的情况,如服务器上的Web应用重启太耗时,这是我们可以考虑用下面的方法. 使用dumpclass,目前dumpclass在Windows上表现不佳,建议在Linux上使用 dumpclass项目地址 https://github.com/hengyunabc/dumpclass 下载地址 http://central.maven.org/maven2/io/github/hengyunabc/dumpclass/0.0.2/dumpclass-0			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qKjKWM.html" rel="bookmark">Java逆向基础之ODB动态调试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说明: 1在&lt;透视JAVA-反编译修补和逆向工程技术&gt;提到了这个工具,这里简单介绍一些 2ODB(即Omniscient Debugger)最新版本已经迁移到github上 3ODB支持的最高JDK版本是1.6,用来分析新版本的jar包和类会报各种异常,从内心的角度来说还是不太想介绍这个工具的 OmniscientDebugger ODB的使用 下载 github方式 https://github.com/OmniscientDebugger/LewisOmniscientDebugger/r			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pvQYo0.html" rel="bookmark" class="title">module&sol;config&sol;module&period;config&period;php文件内涵定义</a>
					<div>
						'router'                     =&gt;array(),// 路由 'controllers'              =&gt;array(),// 控制器 'view ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4peQjgM.html" rel="bookmark" class="title">flask 继承模版的基本使用1</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pelbKM.html" rel="bookmark" class="title">一维数组</a>
					<div>
						数组:相同数据类型的元素按照一定的顺序进行排列生成的集合一组数据 一维数组: int [] array=new int[5]; int[] array = new int[] {1,2,3,4,5 } ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8PGk0.html" rel="bookmark" class="title">java中的一般异常与运行时异常</a>
					<div>
						Java提供了两类主要的异常:runtime exception和checked exception.checked 异常也就是我们经常遇到的IO异常,以及SQL异常都是这种异常.对于这种异常,JAV ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gjkG0.html" rel="bookmark" class="title">跟着文档学python（二）：time&period;time&lpar;&rpar; 与 time&period;clock&lpar;&rpar; 的对比与总结</a>
					<div>
						一,两个函数的文档: 1,time.time(): time.time() Return the time in seconds since the epoch as a floating point ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47qOPD0.html" rel="bookmark" class="title">SSMS 2005 连接 SQL SERVER 2008问题</a>
					<div>
						用本机的 Microsoft SQL Server Management Studio 2005 客户端连接数据库服务器时报错:&quot;This version of Microsoft SQL  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KqAm94.html" rel="bookmark" class="title">xml&period;dom&period;minidom</a>
					<div>
						import xml.dom.minidom document = &quot;&quot;&quot; &lt;slideshow&gt; &lt;title&gt;Demo slideshow&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZDznGM.html" rel="bookmark" class="title">fdhxdgdsfhdjdfgshs</a>
					<div>
						http://www.shangshu.cc/0/4/13756882.html http://www.shangshu.cc/0/4/13756883.html http://www.shangsh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kZw27M.html" rel="bookmark" class="title">【问题收集&CenterDot;初级问题】模拟器和真机，分别如何指定数据库路径，模拟器和真机对应的沙盒有何不同&hellip;</a>
					<div>
						模拟器和真机,分别如何指定数据库路径,模拟器和真机对应的沙盒有何不同- 网友的问题如下所示: 23:58:19 但是原理搞不太懂... 网友的问题如下所示: 23:59:28 我在项目中用了一个数据库 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ML2Emd3.html" rel="bookmark" class="title">Java集合系列：-----------01集合的整体框架</a>
					<div>
						内容来自:http://www.cnblogs.com/skywang12345/p/3308498.html Java集合是java提供的工具包,包含了常用的数据结构:集合.链表.队列.栈.数组.映 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49WQdW0.html" rel="bookmark" class="title">Java for LeetCode 089 Gray Code</a>
					<div>
						The gray code is a binary numeral system where two successive values differ in only one bit. Given a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35rRej4.html" rel="bookmark" class="title">Windows下擴展ubuntu虛擬機的分區大小</a>
					<div>
						在虛擬分區上安裝ubuntu,8G的分区不够用,不願意重装,增加VM分区吧!先备份虛擬硬盤文件 VMWARE自带的工具:找到vmware安装目录下vmware-vdiskmanager.exe,双击無 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkbQ83.html" rel="bookmark" class="title">奢华逆天的iFunk超极本新品即将诞生</a>
					<div>
						最近小编注意到iFunk出了最新消息,iFunk超极本终于要出新款了!But!虽然还不是官方声明,但相信不会空穴来风,iFunk最近一定会有大动向! 纵观iFunk超极本的系列产品,我们不难看出,iF ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLx5KWM.html" rel="bookmark" class="title">常见的网页加载进度条</a>
					<div>
						&lt;style type=&quot;text/css&quot;&gt; /*遮罩在加载页面上的div样式*/ .loading{ width: 100%; height: 100%; posi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j9pE7M.html" rel="bookmark" class="title">Java网页小程序&mdash;&mdash;Java Applet</a>
					<div>
						Java Applet是编译过的Java程序,可以在所以支持Java的浏览器中运行. 1.Applet的使用 import java.applet.Applet; import java.awt.Gr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J2pal4.html" rel="bookmark" class="title">SQL 数字金额转为英文形式</a>
					<div>
						摘录自 http://blog.sina.com.cn/s/blog_43ad83920100nkfp.html 1 IF EXISTS ( SELECT * 2 FROM SYS.OBJECTS 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02qK5AM.html" rel="bookmark" class="title">2016&period;05工作日志</a>
					<div>
						05.01 昨天已经解决json传递的问题,今天本来打算悠闲地看看C++,学学OS.结果早上习惯性地摆弄了下日向blog项目代码,发现一个问题,就是user类save失败.是mysql主键自增长设置失 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38DRk23.html" rel="bookmark" class="title">初识cross apply &amp;amp&semi; outer apply</a>
					<div>
						1. 2. 3.参考地址: http://blog.csdn.net/htl258/article/details/4537421					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NROd64.html" rel="bookmark" class="title">多线程14-Barrier</a>
					<div>
						class Program    {        static Barrier barrier = new Barrier(2, b =&gt; Console.WriteLine(&quot;En ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0b6y190.html" rel="bookmark" class="title">数据库启动的不同状态</a>
					<div>
						启动数据库时先要找到初始化文件(spfile或pfile),此时数据库处在nomount状态(初始阶段):其次根据初始文件找到控制文件(Control File),此时数据库处在mount状态:然后根 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
